// swift-tools-version: 5.6
// The swift-tools-version declares the minimum version of Swift required to build this package.

import PackageDescription

let package = Package(
    name: "swift-discord",
    platforms: [
         .macOS(.v10_15),
         .macCatalyst(.v13),
         .iOS(.v13),
         .tvOS(.v13),
         .watchOS(.v6),
    ],
    products: [
        // Products define the executables and libraries a package produces, and make them visible to other packages.
        .library(
            name: "Discord",
            targets: ["DiscordV10", "Discord"]),
    ],
    dependencies: [
        // Dependencies declare other packages that this package depends on.
        // .package(url: /* package url */, from: "1.0.0"),
        .package(url: "https://github.com/apple/swift-collections.git", .upToNextMajor(from: "1.0.0")),
        .package(url: "https://github.com/sinoru/swift-snowflake", .upToNextMinor(from: "0.0.1")),
    ],
    targets: [
        // Targets are the basic building blocks of a package. A target can define a module or a test suite.
        // Targets can depend on other targets in this package, and on products in packages this package depends on.
        .target(
            name: "DiscordV10",
            dependencies: ["Discord"]),
        .target(
            name: "Discord",
            dependencies: [
                .product(name: "Collections", package: "swift-collections"),
                .product(name: "Snowflake", package: "swift-snowflake")
            ]),
        .target(
            name: "_DiscordTestSupport",
            dependencies: ["Discord"]),
        .testTarget(
            name: "DiscordV10Tests",
            dependencies: ["DiscordV10", "_DiscordTestSupport"]),
        .testTarget(
            name: "DiscordTests",
            dependencies: ["Discord", "_DiscordTestSupport"]),
    ]
)
